using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.Threading;

namespace DirectConnectInternet
{
    public partial class Form1 : Form
    {
        public Form1() {
            InitializeComponent();
        }

        private void DirectGoButton_Click(object sender, EventArgs e) {
            browser.Url = new Uri(urlBox.Text);
        }




        private void sendButton_Click(object sender, EventArgs e) {
            doCommunication();
        }

        private void doCommunication() {
            String hostname = getHostname();
            responseBox.Text = "Hostname:\t" + getHostname();
            int port = getPort();
            responseBox.AppendText("\r\nPort:\t\t" + port);
            toolStripStatusLabel1.Text = "Connecting to " + hostname + " port: " + port;
            try {
                TcpClient mysock = new TcpClient(
                    hostname, port);

                NetworkStream ns = mysock.GetStream();
                byte[] bf = new byte[requestBox.Text.Length];
                char[] ch = requestBox.Text.ToCharArray();
                for (int i = 0; i < ch.Length; i++) {
                    bf[i] = (byte)ch[i];
                }
                ns.Write(bf, 0, bf.Length);
                ns.Flush();

                String s = getReplies(ns);
                responseBox.Text = s;
                int contentLength = getContentLength(s);
                toolStripStatusLabel1.Text = ""+contentLength;
               
                getTheRestOfThePage(ns,contentLength);

                ns.Close();


            }
            catch (Exception e) {
                responseBox.AppendText("\r\nException:\t" + e.Message);
            }



        }

        private int getContentLength(string s) {
            String[] lines = s.Split(new string[] { "\r\n" }, StringSplitOptions.RemoveEmptyEntries);
            foreach(String j in lines){
                if(j.StartsWith("Content-Length:")){

                    int startindex = j.IndexOf(':') + 2;
                    int numchars = j.Length - startindex;
                    String stt = j.Substring(startindex,numchars);
                    try{
                        return(Int32.Parse(stt));
                    }
                    catch {
                        return -1;
                    }
                }
            }
            return -1;
        }
        private void getTheRestOfThePage(NetworkStream nst, int contentlength) {

            int i = 0, counter = 0;
            String s = "";
            responseBox.AppendText("\r\n");
            while (true) {
                counter++;
                if (contentlength >= 0 && counter > contentlength) break;
                i = nst.ReadByte();
                if (i == -1) {
                    break;
                }
                s += (char)i;
            //    responseBox.AppendText(""+(char)i);
            //    Thread.Sleep(0);
            } 
            Uri myuri = new Uri(urlBox.Text);
            browser.DocumentText = "<base href=\""+myuri.GetLeftPart(UriPartial.Authority)+"\">"+s;
            return;

           // int red = nst.ReadByte();
            
        }

        private String getReplies(NetworkStream ns) {
            //This function assumes that the Network Stream is ready for reading from..
            //That is, all the request information have been fed to it.

            String s = "";
            StringBuilder sb = new StringBuilder();
            while (true) {
                int b = ns.ReadByte();
                //sb.Append(b);
                //if (sb.Length>1&&sb.ToString(sb.Length - 2, sb.Length).Equals("\r\n"))
                //    return (sb.ToString());

                if (b == -1) return s;
                s += (char)b;
                if (s.Length > 1 && s.EndsWith("\r\n\r\n")) {
                    //if (s.Length > 1 && s.EndsWith("\r\n")) {
                    return s;
                }
            }


        }
        /// <summary>
        /// Returns the hostname from the Address typed in the Address Bar gracefully.
        /// </summary>
        /// <returns>The Hostname of the target, or null in case of error</returns>
        private String getHostname() {
            String s = urlBox.Text;
            if (s == null || s.Length < 1) {
                return null;
            }
            Uri myuri = new Uri(s);
            return myuri.Host;

        }
        private int getPort() {
            String s = urlBox.Text;
            if (s == null || s.Length < 1) {
                return -1;
            }
            Uri myuri = new Uri(s);
            return myuri.Port;
        }

        private void generateButton_Click(object sender, EventArgs e) {
            String request = "";
            request += "GET ";
            Uri ur = new Uri(urlBox.Text);
            request += ur.AbsolutePath;
            request += " HTTP/1.1\r\n";
            request += "Accept: image/gif, image/x-xbitmap, */*\r\n";
            request += "Accept-Language: en-us\r\n";
            request += "Accept-Encoding: gzip, deflate\r\n";
            request += "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)\r\n";
            request += "Host: localhost:80\r\n";
            request += "Connection: Keep-Alive\r\n";
            request += "\r\n";

            requestBox.Text = request;

        }
    }
}